using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace Snowflakes
{
    /// <summary>
    /// Interaction logic for Snowflake.xaml
    /// </summary>

    public partial class Snowflake : Viewbox
    {
        public Snowflake(SnowflakePic snowflakePic)
        {
            InitializeComponent();

            ImgSource = snowflakePic.ImgSource;
            ImgName = snowflakePic.ImgName;
            IsEnlarged = false;

            ImageBrush imgBrush = new ImageBrush(snowflakePic.Source);
            ellipseBackground.Fill = imgBrush;

            ScaleTrans = new ScaleTransform(0.25, 0.25, 0.5, 0.5);
            TranslateTrans = new TranslateTransform(0.0, 0.0);

            TransformGroup transGroup = new TransformGroup();
            transGroup.Children.Add(ScaleTrans);
            transGroup.Children.Add(TranslateTrans);

            this.RenderTransformOrigin = new Point(0.5, 0.5);
            this.RenderTransform = transGroup;
        }

        string imgSource;
        public string ImgSource
        {
            get { return imgSource; }
            set { imgSource = value; }
        }

        string imgName;
        public string ImgName
        {
            get { return imgName; }
            set { imgName = value; }
        }

        ScaleTransform scaleTrans;
        public ScaleTransform ScaleTrans
        {
            get { return scaleTrans; }
            set
            {
                scaleTrans = value;
                this.RenderTransform = scaleTrans;
            }
        }

        TranslateTransform translateTrans;
        public TranslateTransform TranslateTrans
        {
            get { return translateTrans; }
            set
            {
                translateTrans = value;
                this.RenderTransform = translateTrans;
            }
        }

        double translateTransX;
        public double TranslateTransX
        {
            get { return translateTransX; }
            set { translateTransX = value; }
        }

        double translateTransY;
        public double TranslateTransY
        {
            get { return translateTransY; }
            set { translateTransY = value; }
        }

        int zIndex;
        public int ZIndex
        {
            get { return zIndex; }
            set { zIndex = value; }
        }

        bool isEnlarged;
        public bool IsEnlarged
        {
            get { return isEnlarged; }
            set { isEnlarged = value; }
        }

    }

    public class SnowflakeCollection
    {
        ObservableCollection<Snowflake> snowflakeCollection = new ObservableCollection<Snowflake>();
        public ObservableCollection<Snowflake> SnowflakeCol
        {
            get { return snowflakeCollection; }
        }
    }
}