using System;
using System.Collections.Generic;
using System.Text;
using System.Collections.ObjectModel;
using System.Windows.Media.Imaging;
using System.Windows.Media;
using System.Windows;

namespace Snowflakes
{
    public class SnowflakePic : System.Windows.Controls.Image
    {

        public SnowflakePic(string file)
        {
            // initialize some properties
            ImgSource = file;
            ImgName = file;
            Vis = Visibility.Collapsed;

            // set the initial properties on each SnowflakePic
            this.Source = new BitmapImage(new Uri(ImgSource));

            ScaleTrans = new ScaleTransform(0.25, 0.25, 0.5, 0.5);
            TranslateTrans = new TranslateTransform(0.0, 0.0);

            TransformGroup transGroup = new TransformGroup();
            transGroup.Children.Add(ScaleTrans);
            transGroup.Children.Add(TranslateTrans);
            this.RenderTransform = transGroup;
        }

        #region Properties
        string imgSource;
        public string ImgSource
        {
            get { return imgSource; }
            set { imgSource = value; }
        }

        string imgName;
        public string ImgName
        {
            get { return imgName; }
            set { imgName = ImgSource.Split(new Char[] { '\\' })[6].Split(new Char[] {'.'})[0]; } // hardcoded for simplicity sakes!
        }

        Visibility vis;
        public Visibility Vis
        {
            get { return vis; }
            set
            {
                vis = value;
                this.Visibility = vis;
            }
        }

        ScaleTransform scaleTrans;
        public ScaleTransform ScaleTrans
        {
            get { return scaleTrans; }
            set
            {
                scaleTrans = value;
                this.RenderTransform = scaleTrans;
            }
        }

        TranslateTransform translateTrans;
        public TranslateTransform TranslateTrans
        {
            get { return translateTrans; }
            set
            {
                translateTrans = value;
                this.RenderTransform = translateTrans;
            }
        }
        #endregion
    }

    public class SnowflakePicCollection
    {
        ObservableCollection<SnowflakePic> snowflakePicsCollection = new ObservableCollection<SnowflakePic>();
        public ObservableCollection<SnowflakePic> SnowflakePicsCollection
        {
            get { return snowflakePicsCollection; }
        }
    }
}
